#include <sys/types.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <setjmp.h>
#include <math.h>
#include <assert.h>
#include <stdio.h>	/* for remove */
#include <time.h>	/* for time(2) under Linux */
#include <sys/time.h>
#include <dirent.h>
#include <pwd.h>
#include <grp.h>

#define gmtime p9gmtime
#define localtime p9localtime
#define asctime p9asctime
#define ctime p9ctime

typedef ulong intptr;

#define nil ((void*)0)
#define SET(x) (x)=0
#define USED(x) if((x) && 0){}else
#define ERRMAX 256

#define OREAD   O_RDONLY
#define OWRITE  O_WRONLY
#define ORDWR   O_RDWR
#define OTRUNC  O_TRUNC
#define OEXEC   O_RDONLY  /* botch */
#define OCEXEC  0         /* botch: fcntl */
#define ORCLOSE 0         /* botch */
#define OEXCL   0         /* botch */

#if 0
#define	AEXIST	0	/* accessible: exists */
#define	AEXEC	1	/* execute access */
#define	AWRITE	2	/* write access */
#define	AREAD	4	/* read access */
#endif

#define AEXIST  F_OK
#define AEXEC   X_OK
#define AWRITE  W_OK
#define AREAD   R_OK 

#define seek lseek
#define dup(a, b) dup2(a, b)

typedef
struct Qid
{
	uvlong	path;
	ulong	vers;
	uchar	type;
} Qid;

typedef
struct Dir {
	/* system-modified data */
	ushort	type;	/* server type */
	uint	dev;	/* server subtype */
	/* file data */
	Qid	qid;	/* unique id from server */
	ulong	mode;	/* permissions */
	ulong	atime;	/* last read time */
	ulong	mtime;	/* last write time */
	vlong	length;	/* file length: see <u.h> */
	char	*name;	/* last element of path */
	char	*uid;	/* owner name */
	char	*gid;	/* group name */
	char	*muid;	/* last modifier name */

	/* Unix-specific nonsense -- do not use */
	uint	uidno;
	uint	gidno;
	ulong	ctime;
	mode_t	unixmode;
	char	*symlink;
} Dir;

#if 0 /* Old-style rdproto */
/* proto file parsing */
typedef void Protoenum(char *new, char *old, Dir *d, void *a);
typedef void Protowarn(char *msg, void *a);

int rdproto(char *, char *, Protoenum*, Protowarn*, void *);
#else
/* New-style (tra) protofiles */ 

/*
 * Proto file parsing 
 */
/* BOTCH: argument 3 is a Dir or a Tdir...which is it? */
//typedef int Protoenum(char *new, char *old, Tdir *d, void *a);
typedef int Protoenum(char *new, char *old, Dir *d, void *a);
typedef void Protowarn(char *msg, void *a);

typedef struct Proto Proto;
struct Proto {
	char type;
	char *new;
	char *old;
	char *uid;
	char *gid;
	char *elem;
	ulong mode;
	Proto *kid;
	int nkid;
};

Proto *parseproto(char *file, char *root);
void execproto(Proto*, Protoenum*, Protowarn*, void*);
//int protokids(Proto*, char*, Tdir**);
char *prototranslate(Proto*, char*);
int rdproto(char *, char *, Protoenum*, Protowarn*, void *);

#endif
