/* Copyright (c) Joerg-R. Hill, December 2000 */
#include<dirent.h>
#include<stdlib.h>
#include<string.h>
#include<sys/types.h>

typedef struct dirent Dirent;

#define nil ((void*) 0)

int
scandir(const char *dir, Dirent ***namelist,
            int (*select)(const Dirent *),
            int (*cmp)(const Dirent **, const Dirent **))
{
	DIR *d;
	Dirent *entry;
	register int i=0;
	size_t entrysize;

	if((d=opendir(dir)) == nil)
		return(-1);

	*namelist=NULL;
	while((entry=readdir(d)) != nil){
		if(select == nil || (*select)(entry)){
			*namelist = (Dirent **)realloc((*namelist),
				(size_t)((i+1)*sizeof(Dirent *)));
			if(*namelist == nil)
				return -1;
			entrysize = sizeof(Dirent) - 
				sizeof(entry->d_name)+strlen(entry->d_name)+1;
			(*namelist)[i]=(Dirent *)malloc(entrysize);
			if((*namelist)[i] == nil)
				return -1;
			memcpy((*namelist)[i], entry, entrysize);
			i++;
		}
	}
	if(closedir(d) || i == 0)
		return -1;
	if(cmp != nil)
		qsort(*namelist, (size_t)i, sizeof(Dirent *), (void*)cmp);
	return i;
}

int
alphasort(const Dirent **a, const Dirent **b)
{
	return(strcmp((*a)->d_name, (*b)->d_name));
}
