#include <u.h>
#include <libc.h>

static int flagconv(int f);
static int permconv(int p);

int
create(char *file, int omode, ulong perm)
{
	int fd;
	fd = open(file, O_CREAT|flagconv(omode), permconv(perm));
	return fd;
}

static int 
flagconv(int f)
{
	switch(f) {
	case OWRITE:
		return O_WRONLY;
	case OREAD:
		return O_RDONLY;
	case ORDWR:
		return O_RDWR;
	}
	return O_RDONLY;
}

static int
permconv(int p)
{
	int n;
	n = p;
	if (p & DMDIR) {
		n &= ~(DMDIR);
		n |= S_IFDIR;
	}
	return n;
}
