#include <u.h>
#include <libc.h>

#undef gmtime
#undef localtime
#undef ctime
#undef asctime

static Tm
tmcvt(struct tm *v)
{
	Tm u;

	u.sec = v->tm_sec;
	u.min = v->tm_min;
	u.hour = v->tm_hour;
	u.mday = v->tm_mday;
	u.mon = v->tm_mon;
	u.year = v->tm_year;
	u.wday = v->tm_wday;
	u.yday = v->tm_yday;
//	u.tzoff = v->tm_gmtoff;
	u.isdst = v->tm_isdst;
//	strncpy(u.zone, v->tm_zone, sizeof(u.zone));
//	u.zone[3] = '\0';
	u.zone[0] = '\0';

	return u;
}

Tm*
p9gmtime(long t)
{
	static Tm u;
	time_t time;
	
	memset(&u, 0, sizeof(Tm));
	time = ((time_t) t);
	u = tmcvt(gmtime(&time));
	
	return &u;
}


Tm*
p9localtime(long t)
{
	static Tm u;
	time_t time;
	
	memset(&u, 0, sizeof(Tm));
	time = ((time_t) t);
	u = tmcvt(localtime(&time));
	return &u;
}

char*
p9ctime(long t)
{
	return ctime((const time_t *) &t);
}

char*
p9asctime(Tm *u)
{
	struct tm v;

	memset(&v, 0, sizeof v);
	v.tm_sec = u->sec;
	v.tm_min = u->min;
	v.tm_hour = u->hour;
	v.tm_mday = u->mday;
	v.tm_mon = u->mon;
	v.tm_year = u->year;
	v.tm_wday = u->wday;
	v.tm_yday = u->yday;
//	v.tm_gmtoff = u->tzoff;
	v.tm_isdst = u->isdst;
	/* XXX: copy zone back */

	return asctime(&v);
}
